# Project Setup and Execution

## Prerequisites

1. **Install Pagmo Library:**
   - Ensure that the Pagmo C++ library and all its dependencies are installed on your system.

2. **Update Makefile:**
   - Modify the `Makefile` to include the correct paths to the installed libraries.

## Running the Project

1. **Compile the Project:**
   - Open a terminal and navigate to the project directory.
   - Run the following command to compile the project:
     ```bash
     make
     ```

2. **Run the Application:**
   - After successful compilation, execute the program with:
     ```bash
     ./dsl
     ```
   - This will perform run the Dynamic Structure Learning (DSL) framework by running SAEM to learn the best fitting model parameters and then computing the most likely RL agent structure in each session by taking the MAP of the smoothed distribution of agent structures (or strategies).

   - Simulation recovery tests to validate the DSL method by calling testRecovery function (defined in Generate) in runEm.cpp.